//PasScript interpreter of the Object Pascal language, version 3.0
//Copyright (c) by Alexander Baranovsky, 1999-2000
//File '_inter.pas'

unit _inter;
interface

function GetParam( N : Integer ) : Variant;
procedure Return( const Result : Variant );

implementation

uses
  Windows;

type
  TVariantArray = array[0..30] of Variant;
  PVariantArray = ^TVariantArray;
var
  hMapFile : THandle;
  MapFilePointer : PVariantArray;

function GetParam( N : Integer ) : Variant;
begin
  result := EmptyParam;

  hMapFile := OpenFileMapping( File_Map_All_Access, false, 'PasScriptArea' );

  if hMapFile = 0 then
    Exit;
 
  MapFilePointer := MapViewOfFile( hMapFile, File_Map_All_Access, 0, 0, 0 );

  result := MapFilePointer^[ N ];
end;

procedure Return( const Result : Variant );
begin
  hMapFile := OpenFileMapping( File_Map_All_Access, false, 'PasScriptArea' );

  if hMapFile = 0 then
    Exit;
 
  MapFilePointer := MapViewOfFile( hMapFile, File_Map_All_Access, 0, 0, 0 );

  MapFilePointer^[0] := Result;
end;

end.